.NOLIST
.INCLUDE "m128def.inc"
.INCLUDE "_macros.asm"

.MACRO  LED_ON
        CBI     PORTB,7
.ENDMACRO

.MACRO  LED_OFF
        SBI     PORTB,7
.ENDMACRO

.LIST
.LISTMAC

.DEF    POLY_LO =R06    ;ᥣ = $21
.DEF    POLY_HI =R07    ;ᥣ = $10
.DEF    FF_FL   =R08
.DEF    CRC_LO  =R09
.DEF    CRC_HI  =R10
.DEF    ADR1    =R11
.DEF    ADR2    =R12
.DEF    FF      =R13    ;ᥣ = $FF
.DEF    ONE     =R14    ;ᥣ = $01
.DEF    NULL    =R15    ;ᥣ = $00
.DEF    DATA    =R16
.DEF    TEMP    =R17
.DEF    COUNT   =R18
.DEF    BITS    =R19
;쭮 ᯮ: R0,R1,R20,R21,R24,R25
;
.EQU    DBSIZE_HI       =HIGH(4096)
.EQU    DBMASK_HI       =HIGH(4095)
.EQU    nCONFIG         =PORTF0
.EQU    nSTATUS         =PORTF1
.EQU    CONF_DONE       =PORTF2
;
;--------------------------------------
;
.DSEG
        .ORG    $0100
BUFFER:                 ; 
;
;--------------------------------------
;
.CSEG
        .ORG    $F000
BOOTLOADER_BEGIN:
RESET:  CLI
        LED_ON
        SBI     DDRB,7
        LDI     TEMP,      0B00001000 ; ATX on
        OUTPORT DDRF,TEMP
        OUTPORT PORTF,TEMP
;
        CLR     NULL
        LDI     TEMP,$01
        MOV     ONE,TEMP
        LDI     TEMP,$FF
        MOV     FF,TEMP
        LDI     TEMP,$21
        MOV     POLY_LO,TEMP
        LDI     TEMP,$10
        MOV     POLY_HI,TEMP
        LDI     TEMP,LOW(RAMEND)
        OUT     SPL,TEMP
        LDI     TEMP,HIGH(RAMEND)
        OUT     SPH,TEMP
;WatchDog OFF, ᫨  祭
        LDI     TEMP,0B00011111
        OUT     WDTCR,TEMP
        OUT     WDTCR,NULL
;UART1 Set baud rate
        OUTPORT UBRR1H,NULL
        LDI     TEMP,5     ;115200 baud @ 11059.2 kHz, Normal speed
        OUTPORT UBRR1L,TEMP
;UART1 Normal Speed
        OUTPORT UCSR1A,NULL
;UART1 data8bit, 2stopbits
        LDI     TEMP,(1<<UCSZ1)|(1<<UCSZ0)|(1<<USBS)
        OUTPORT UCSR1C,TEMP
;UART1 蠥 ।
        LDI     TEMP,(1<<TXEN)
        OUTPORT UCSR1B,TEMP
;
        LDIZ    MSG_HELLO*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_OFF
        LDIZ    MSG_WORLD*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_ON
        LDIZ    MSG_HELLO*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_OFF
        LDIZ    MSG_WORLD*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_ON
        LDIZ    MSG_HELLO*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_OFF
        LDIZ    MSG_WORLD*2
        RCALL   PRINTSTRZ
        LDI     DATA,5
        RCALL   DELAY
        LED_ON
;
;
;
        CLR     NULL
        LDI     TEMP,$01
        MOV     ONE,TEMP
        LDI     TEMP,$FF
        MOV     FF,TEMP
        LDI     TEMP,$21
        MOV     POLY_LO,TEMP
        LDI     TEMP,$10
        MOV     POLY_HI,TEMP
;뢮 ଠ樨  ᨨ
        LDIZ    MSG_NEWLINE*2
        RCALL   PRINTSTRZ
        LDIZ    BOOT_VERS*2
        RCALL   PRINTVERS
;஢ઠ CRC 稪
        LDIZ    BOOTLOADER_BEGIN*2              ;  
        OUT     RAMPZ,ONE
        LDIY    BOOTLOADER_END-BOOTLOADER_BEGIN ;  ᫮
        RCALL   CALK_CRC_FLASH
        BREQ    LDFPGA
;
        LDIZ    MSG_XPEHOBO*2
        RCALL   PRINTSTRZ
XP1:    LDI     DATA,1
        RCALL   DELAY
        LED_OFF
        LDI     DATA,1
        RCALL   DELAY
        LED_ON
        RJMP    XP1
;
LDFPGA:
        LDI     TEMP,      0B01111001 ;
        OUT     PORTB,TEMP
        LDI     TEMP,      0B10000111 ; LED on, spi outs
        OUT     DDRB,TEMP
;SPI init
        LDI     TEMP,(1<<SPI2X)
        OUT     SPSR,TEMP
        LDI     TEMP,(1<<SPE)|(1<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)
        OUT     SPCR,TEMP
; 祭 ATX,  ⮬  -.
UP11:   SBIS    PINF,0 ;PINC,5 ;  ᫨ powergood   ?
        RJMP    UP11
        LDI     DATA,5
        RCALL   DELAY

        LDIZ    MSG_CFGFPGA*2
        RCALL   PRINTSTRZ
;㧪 FPGA
        INPORT  TEMP,DDRF
        SBR     TEMP,(1<<nCONFIG)
        OUTPORT DDRF,TEMP

        LDI     TEMP,147 ;40 us @ 11.0592 MHz
LDFPGA1:DEC     TEMP    ;1
        BRNE    LDFPGA1 ;2

        INPORT  TEMP,DDRF
        CBR     TEMP,(1<<nCONFIG)
        OUTPORT DDRF,TEMP

LDFPGA2:SBIS    PINF,nSTATUS
        RJMP    LDFPGA2

        LDIZ    PACKED_FPGA*2
        OUT     RAMPZ,ONE
        LDIY    BUFFER
;( ண ⥪!    )
        LDI     TEMP,$80
MS:     ELPM    R0,Z+
        ST      Y+,R0
;-begin-PUT_BYTE_1---
        OUT     SPDR,R0
PUTB1:  SBIS    SPSR,SPIF
        RJMP    PUTB1
;-end---PUT_BYTE_1---
        SUBI    YH,HIGH(BUFFER) ;
        ANDI    YH,DBMASK_HI    ;Y warp
        ADDI    YH,HIGH(BUFFER) ;
M0:     LDI     R21,$02
        LDI     R20,$FF
M1:
M1X:    ADD     TEMP,TEMP
        BRNE    M2
        ELPM    TEMP,Z+
        ROL     TEMP
M2:     ROL     R20
        BRCC    M1X
        DEC     R21
        BRNE    X2
        LDI     DATA,2
        ASR     R20
        BRCS    N1
        INC     DATA
        INC     R20
        BREQ    N2
        LDI     R21,$03
        LDI     R20,$3F
        RJMP    M1
X2:     DEC     R21
        BRNE    X3
        LSR     R20
        BRCS    MS
        INC     R21
        RJMP    M1
X6:     ADD     DATA,R20
N2:     LDI     R21,$04
        LDI     R20,$FF
        RJMP    M1
N1:     INC     R20
        BRNE    M4
        INC     R21
N5:     ROR     R20
        BRCS    DEMLZEND
        ROL     R21
        ADD     TEMP,TEMP
        BRNE    N6
        ELPM    TEMP,Z+
        ROL     TEMP
N6:     BRCC    N5
        ADD     DATA,R21
        LDI     R21,6
        RJMP    M1
X3:     DEC     R21
        BRNE    X4
        LDI     DATA,1
        RJMP    M3
X4:     DEC     R21
        BRNE    X5
        INC     R20
        BRNE    M4
        LDI     R21,$05
        LDI     R20,$1F
        RJMP    M1
X5:     DEC     R21
        BRNE    X6
        MOV     R21,R20
M4:     ELPM    R20,Z+
M3:     DEC     R21
        MOV     XL,R20
        MOV     XH,R21
        ADD     XL,YL
        ADC     XH,YH
LDIRLOOP:
        SUBI    XH,HIGH(BUFFER) ;
        ANDI    XH,DBMASK_HI    ;X warp
        ADDI    XH,HIGH(BUFFER) ;
        LD      R0,X+
        ST      Y+,R0
;-begin-PUT_BYTE_2---
        OUT     SPDR,R0
PUTB2:  SBIS    SPSR,SPIF
        RJMP    PUTB2
;-end---PUT_BYTE_2---
        SUBI    YH,HIGH(BUFFER) ;
        ANDI    YH,DBMASK_HI    ;Y warp
        ADDI    YH,HIGH(BUFFER) ;
        DEC     DATA
        BRNE    LDIRLOOP
        RJMP    M0
;⥯   ⥪
DEMLZEND:
        SBIS    PINF,CONF_DONE
        RJMP    DEMLZEND
;SPI reinit
        LDI     TEMP,(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)
        OUT     SPCR,TEMP
        SBI     PORTE,6
        LED_OFF
        LDIZ    MSG_MAINOK*2
        RCALL   PRINTSTRZ

MLOOP:  LDIZ    MSG_HELLO*2
        RCALL   PRINTSTRZ
        LED_ON
        LDI     DATA,5
        RCALL   BEEP
        LDIZ    MSG_WORLD*2
        RCALL   PRINTSTRZ
        LED_OFF
        LDI     DATA,5
        RCALL   DELAY
        RJMP    MLOOP
;
;======================================
;
PRINTVERS:
        LDI     COUNT,12
PRVERS2:ELPM    DATA,Z+
        TST     DATA
        BREQ    PRVERS1
        BRMI    PRVERS1
        RCALL   WRUART
        DEC     COUNT
        BRNE    PRVERS2
PRVERS1:LDI     DATA,$20
        RCALL   WRUART
        LDI     ZL,$FC
        ELPM    XL,Z+
        ELPM    XH,Z+
        MOV     DATA,XL
        ANDI    DATA,$1F
        BREQ    PRVERS9
        MOV     TEMP,XH
        LSL     XL
        ROL     TEMP
        LSL     XL
        ROL     TEMP
        LSL     XL
        ROL     TEMP
        ANDI    TEMP,$0F
        BREQ    PRVERS9
        CPI     TEMP,13
        BRCC    PRVERS9
        MOV     COUNT,XH
        LSR     COUNT
        ANDI    COUNT,$3F
        CPI     COUNT,9
        BRCS    PRVERS9
        RCALL   DECBYTE
        LDI     DATA,$2E
        RCALL   WRUART
        MOV     DATA,TEMP
        RCALL   DECBYTE
        LDI     DATA,$2E
        RCALL   WRUART
        LDI     DATA,$20
        RCALL   HEXBYTE
        MOV     DATA,COUNT
        RCALL   DECBYTE
        SBRC    XH,7
PRVERS9:RET
;
;--------------------------------------
;
BETA:   LDIZ    MSG_BETA*2
        RJMP    PRINTSTRZ
;
;--------------------------------------
;in:    Z == 㪠⥫쭠 ப (  64K)
PRINTSTRZ:
        OUT     RAMPZ,ONE
PRSTRZ1:ELPM    DATA,Z+
        TST     DATA
        BREQ    PRSTRZ2
        RCALL   WRUART
        RJMP    PRSTRZ1
PRSTRZ2:RET
;
;--------------------------------------
;byte in dec to uart
;in:    DATA == byte (0..99)
DECBYTE:SUBI    DATA,208
        SBRS    DATA,7
        SUBI    DATA,48
        SUBI    DATA,232
        SBRS    DATA,6
        SUBI    DATA,24
        SUBI    DATA,244
        SBRS    DATA,5
        SUBI    DATA,12
        SUBI    DATA,250
        SBRS    DATA,4
        SUBI    DATA,6
;
; - - - - - - - - - - - - - - - - - - -
;byte in hex to uart
;in:    DATA == byte
HEXBYTE:PUSH    DATA
        SWAP    DATA
        RCALL   HEXHALF
        POP     DATA
HEXHALF:ANDI    DATA,$0F
        CPI     DATA,$0A
        BRCS    HEXBYT1
        ADDI    DATA,$07
HEXBYT1:ADDI    DATA,$30
;
; - - - - - - - - - - - - - - - - - - -
;in:    DATA == । 
WRUART: PUSH    TEMP
WRU_1:  INPORT  TEMP,UCSR1A
        SBRS    TEMP,UDRE
        RJMP    WRU_1
        OUTPORT UDR1,DATA
        POP     TEMP
        RET
;
;--------------------------------------
;in:    DATA == த⥫쭮 *0.1 ᥪ
BEEP:   OUT     SPCR,NULL       ;SPI off
BEE2:   LDI     TEMP,100;100 ਮ 1
BEE1:   SBI     DDRE,6
        CBI     PORTE,6
        RCALL   BEEPDLY
        CBI     DDRE,6
        SBI     PORTE,6
        RCALL   BEEPDLY
        DEC     TEMP
        BRNE    BEE1
        DEC     DATA
        BRNE    BEE2
        RET

BEEPDLY:LDI     R24,$64
        LDI     R25,$05
BEEPDL1:SBIW    R24,1
        BRNE    BEEPDL1
        RET
;
;--------------------------------------
;in:    DATA == த⥫쭮 *0.1 ᥪ
DELAY:
        LDI     R20,$1E ;\
        LDI     R21,$FE ;/ 0,1 ᥪ @ 11.0592MHz
DELAY1: LPM             ;3
        LPM             ;3
        LPM             ;3
        LPM             ;3
        SUBI    R20,1   ;1
        SBCI    R21,0   ;1
        SBCI    DATA,0  ;1
        BRNE    DELAY1  ;2(1)
        RET
;
;--------------------------------------
;in:    Z ==   
;       Y == - ᫮
;out:   sreg.Z == SET - crc ok!
CALK_CRC_FLASH:
        MOV     CRC_LO,FF
        MOV     CRC_HI,FF
CCRCFL1:ELPM    DATA,Z+
        RCALL   CRC_UPDATE
        ELPM    DATA,Z+
        RCALL   CRC_UPDATE

        LED_OFF
        SBRS    ZH,5
        LED_ON  ;   CRC

        SBIW    YL,1
        BRNE    CCRCFL1
        OR      CRC_LO,CRC_HI
        RET
;
;--------------------------------------
;in:    DATA - byte
;       CRC_LO,CRC_HI
;out:   CRC_LO,CRC_HI
;cng:   TEMP
CRC_UPDATE:
        EOR     CRC_HI,DATA
        LDI     TEMP,8
CRC_UP2:LSL     CRC_LO
        ROL     CRC_HI
        BRCC    CRC_UP1
        EOR     CRC_LO,POLY_LO
        EOR     CRC_HI,POLY_HI
CRC_UP1:DEC     TEMP
        BRNE    CRC_UP2
        RET
;
;--------------------------------------
;
MSG_NEWLINE:
        .DB     $0D,$0A,0,0
MSG_BETA:
        .DB     " beta",0
MSG_HELLO:
        .DB     $0A,$0A,$0D,"Hello ",0
MSG_WORLD:
        .DB     "world!",0,0
MSG_XPEHOBO:
        .DB     $0D,$0A,"BCE XPEHOBO! Change your ATMEGA-chip.",$0D,$0A,0
MSG_CFGFPGA:
        .DB     $0D,$0A,"Set temporary configuration... ",0
MSG_MAINOK:
        .DB     "Ok!",0
;
PACKED_FPGA:
.NOLIST
.INCLUDE "fpga.inc"
.LIST
;
;--------------------------------------
;
        .ORG    FLASHEND-$0007
BOOT_VERS:
        .DW     0,0,0,0,0,0     ; 㤥 窠 ⥫ bootloader-
        .DW     0               ; 㤥 () bootloader-
        .DW     0               ; 㤥 CRC bootloader-
BOOTLOADER_END:
